﻿Public Class frmFRAM_Editor
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Private Sub RelayRequest_Click(sender As Object, e As EventArgs) Handles RelayRequest.Click
        If StartAddress.Value > 240 Then
            StartAddress.Value = 0
        Else
            StartAddress.Value = StartAddress.Value + 16
        End If
    End Sub
    Private Sub RelayRecord_Click(sender As Object, e As EventArgs) Handles RelayRecord.Click

        If StartAddress.Value < 256 Or StartAddress.Value > (512 - 16) Then
            StartAddress.Value = 256
        Else
            StartAddress.Value = StartAddress.Value + 16
        End If

    End Sub
    Private Sub RelayAddress_Click(sender As Object, e As EventArgs) Handles RelayAddress.Click

        If StartAddress.Value < 512 Or StartAddress.Value > (768 - 15) Then
            StartAddress.Value = 512
        Else
            StartAddress.Value = StartAddress.Value + 16
        End If

    End Sub
    Private Sub RelayActual_Click(sender As Object, e As EventArgs) Handles RelayActual.Click

        If StartAddress.Value < 768 Or StartAddress.Value > (1024 - 16) Then
            StartAddress.Value = 768
        Else
            StartAddress.Value = StartAddress.Value + 16
        End If

    End Sub

    Private Sub frmFRAM_Editor_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'Add Rows
        For Temp As Integer = 1 To 16
            DataTable.Rows.Add()
            DataTable2.Rows.Add()
        Next Temp


        FillTableA()
        FillTableB()
        FormLoading = False
    End Sub

    Private Sub StartAddress_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress.ValueChanged

        If FormLoading = False Then

            FillTableA()
        End If

    End Sub


    Public Sub FillTableA()

        Dim I(15) As Byte

        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)

        If I IsNot Nothing Then
            For Y As Integer = 0 To 15

                Dim Address As Double = StartAddress.Value + Y
                Dim Hex_Value As String

                Hex_Value = Hex(Address)
                CellData(0, Y, Address.ToString + "-" + Hex_Value)
                CellData(1, Y, Hex(I(Y)).ToString)
                CellData(2, Y, I(Y).ToString)
                CellData(3, Y, NCDLib.Math.DecToBinaryStringStandard(I(Y)))
                CellData(5, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))

            Next Y
        End If
    End Sub

    Public Sub FillTableB()

        Dim I(15) As Byte

        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress2.Value, 16)


        If I IsNot Nothing Then

            For Y As Integer = 0 To 15

                Dim Address As Double = StartAddress2.Value + Y
                Dim Hex_Value As String

                Hex_Value = Hex(Address)
                CellData2(0, Y, Address.ToString + "-" + Hex_Value)
                CellData2(1, Y, Hex(I(Y)).ToString)
                CellData2(2, Y, I(Y).ToString)
                CellData2(3, Y, NCDLib.Math.DecToBinaryStringStandard(I(Y)))
                CellData2(4, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))

            Next Y
        End If

    End Sub
    Public Sub CellData(x As Integer, Y As Integer, Dat As String)
        DataTable(x, Y).Value = Dat
    End Sub
    Public Function GetCellData(x As Integer, Y As Integer) As String
        GetCellData = DataTable(x, Y).Value
    End Function
    Public Sub CellData2(x As Integer, Y As Integer, Dat As String)
        DataTable2(x, Y).Value = Dat
    End Sub
    Public Function GetCellData2(x As Integer, Y As Integer) As String
        GetCellData2 = DataTable2(x, Y).Value
    End Function




    Private Sub RelayRequest2_Click(sender As Object, e As EventArgs) Handles RelayRequest2.Click
        If StartAddress2.Value > 240 Then
            StartAddress2.Value = 0
        Else
            StartAddress2.Value = StartAddress2.Value + 16
        End If
    End Sub

    Private Sub RelayActual2_Click(sender As Object, e As EventArgs) Handles RelayActual2.Click
        If StartAddress2.Value < 768 Or StartAddress2.Value > (1024 - 16) Then
            StartAddress2.Value = 768
        Else
            StartAddress2.Value = StartAddress2.Value + 16
        End If
    End Sub

    Private Sub RelayRecord2_Click(sender As Object, e As EventArgs) Handles RelayRecord2.Click
        If StartAddress2.Value < 256 Or StartAddress2.Value > (512 - 16) Then
            StartAddress2.Value = 256
        Else
            StartAddress2.Value = StartAddress2.Value + 16
        End If
    End Sub

    Private Sub RelayAddress2_Click(sender As Object, e As EventArgs) Handles RelayAddress2.Click
        If StartAddress2.Value < 512 Or StartAddress2.Value > (768 - 15) Then
            StartAddress2.Value = 512
        Else
            StartAddress2.Value = StartAddress2.Value + 16
        End If
    End Sub
    Private Sub StartAddress2_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress2.ValueChanged
        If FormLoading = False Then
            FillTableB()
        End If
    End Sub
    Private Sub Refresh_Click(sender As Object, e As EventArgs) Handles Refresh.Click
        If FormLoading = False Then
            FillTableA()
            FillTableB()
        End If
    End Sub
    Private Sub DataTable_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataTable.CellContentClick
        If e.ColumnIndex = 4 Then
            If GetCellData(4, e.RowIndex) = "Edit" Then
                'Pass Data from Main Form to Pop-Up
                Debug.Print("Button clicked")
                Dim frm As New frmBinaryEditor
                frm.GPIO = GetCellData(2, e.RowIndex)
                If frm.ShowDialog = DialogResult.OK Then
                    'Pass Data from Pop-Up Bank to Main Form
                    CellData(1, e.RowIndex, Hex(frm.GPIO).ToString)
                    CellData(2, e.RowIndex, frm.GPIO)
                    CellData(3, e.RowIndex, NCDLib.Math.DecToBinaryStringStandard(frm.GPIO))
                End If
            End If
        End If

        If e.ColumnIndex = 6 Then
            If GetCellData(6, e.RowIndex) = "Random" Then
                Dim RandomNumber As Integer = Math.Ceiling(Rnd() * 255)
                CellData(2, e.RowIndex, RandomNumber.ToString)
                CellData(3, e.RowIndex, NCDLib.Math.DecToBinaryStringStandard(RandomNumber))
                SaveRefresh()
            End If
        End If


    End Sub

    Private Sub Save_Click(sender As Object, e As EventArgs) Handles Save.Click

        SaveRefresh()

    End Sub

    Public Sub SaveRefresh()
        'Setup a Container for Data
        Dim I(15) As Byte
        'Copy Data from Cells into Container Array
        For CellCount As Integer = 0 To 15
            I(CellCount) = GetCellData(2, CellCount)
        Next CellCount
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        'Refresh Tables
        If FormLoading = False Then
            FillTableA()
            FillTableB()
        End If
    End Sub

    Private Sub FillRandom_Click(sender As Object, e As EventArgs) Handles FillRandom.Click

        'Setup a Container for Data
        Dim I(15) As Byte
            For CellCount As Integer = 0 To 15
                I(CellCount) = Math.Ceiling(Rnd() * 255)
            Next CellCount
            'Store Container Array at the Selected Start Address
            NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        'Refresh Tables
        If FormLoading = False Then
            FillTableA()
            FillTableB()
        End If

    End Sub

    Private Sub ErrorFlags_Click(sender As Object, e As EventArgs) Handles ErrorFlags.Click
        StartAddress.Value = 1024
    End Sub

    Private Sub ErrorFlags2_Click(sender As Object, e As EventArgs) Handles ErrorFlags2.Click
        StartAddress2.Value = 1024
    End Sub

    Private Sub ClearErrors_Click(sender As Object, e As EventArgs) Handles ClearErrors.Click
        'Setup a Container for Data
        Dim I(15) As Byte
        For CellCount As Integer = 0 To 15
            I(CellCount) = 0
        Next CellCount
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, 1024, I)
        'Refresh Tables
        If FormLoading = False Then
            FillTableA()
            FillTableB()
        End If
    End Sub

    Private Sub Refill_CheckedChanged(sender As Object, e As EventArgs) Handles Refill.CheckedChanged
        While Refill.Checked = True
            'Setup a Container for Data
            Dim I(15) As Byte
            For CellCount As Integer = 0 To 15
                I(CellCount) = Math.Ceiling(Rnd() * 255)
            Next CellCount
            'Store Container Array at the Selected Start Address
            NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)


            'NCDComponent1.Sleep(200)



        End While

    End Sub

    Private Sub ClearSector_Click(sender As Object, e As EventArgs) Handles ClearSector.Click

        'Setup a Container for Data
        Dim I(15) As Byte
        'Copy Data from Cells into Container Array
        For CellCount As Integer = 0 To 15
            I(CellCount) = 0 'GetCellData(2, CellCount)
        Next CellCount
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress.Value, I)

        'Refresh Tables
        If FormLoading = False Then
            FillTableA()
            FillTableB()
        End If


    End Sub

    Private Sub RelayPowerUpStatus_Click(sender As Object, e As EventArgs) Handles RelayPowerUpStatus.Click

        StartAddress2.Value = 2576


    End Sub
End Class