﻿Public Class frmType40_VibrationV2
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type40 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type40

    Private Sub frmType40_VibrationV2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 40 Vibration Sensor V2 - Address: " + SensorAddress

        Timer1.Interval = 3000
        Timer1.Start()

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            RMSX.Text = Type40.RMSX.ToString
            RMSY.Text = Type40.RMSY.ToString
            RMSZ.Text = Type40.RMSZ.ToString

            MAXX.Text = Type40.MAXX.ToString
            MAXY.Text = Type40.MAXY.ToString
            MAXZ.Text = Type40.MAXZ.ToString

            MINX.Text = Type40.MINX.ToString
            MINY.Text = Type40.MINY.ToString
            MINZ.Text = Type40.MINZ.ToString

            Celsius.Text = Type40.Celsius
            Fahrenheit.Text = Type40.Fahrenheit

        End If
    End Sub


End Class