﻿Public Class frmType7_ImpactDetection
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type7 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type7
    Private Sub frmType7_ImpactDetection_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 7 Impact Detection Sensor - Address: " + SensorAddress

        Timer1.Interval = 3000
        Timer1.Start()
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then

            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            X1.Text = Type7.X1.ToString
            X2.Text = Type7.X2.ToString
            X.Text = Type7.X.ToString

            Y1.Text = Type7.Y1.ToString
            Y2.Text = Type7.Y2.ToString
            Y.Text = Type7.Y.ToString

            Z1.Text = Type7.Z1.ToString
            Z2.Text = Type7.Z2.ToString
            Z.Text = Type7.Z.ToString
        End If
    End Sub
    Private Sub frmfrmType7_ImpactDetection_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub
End Class