﻿Public Class frmType8_Vibration
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type8 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type8
    Private Sub frmType8_Vibration_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 8 Vibration Sensor - Address: " + SensorAddress

        Timer1.Interval = 3000
        Timer1.Start()

    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            RMSX.Text = Type8.RMSX.ToString
            RMSY.Text = Type8.RMSY.ToString
            RMSZ.Text = Type8.RMSZ.ToString

            MAXX.Text = Type8.MAXX.ToString
            MAXY.Text = Type8.MAXY.ToString
            MAXZ.Text = Type8.MAXZ.ToString

            MINX.Text = Type8.MINX.ToString
            MINY.Text = Type8.MINY.ToString
            MINZ.Text = Type8.MINZ.ToString

            Celsius.Text = Type8.Celsius
            Fahrenheit.Text = Type8.Fahrenheit

        End If

    End Sub

    Private Sub frmfrmType8_Vibration_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub

End Class